#!/usr/bin/env ruby

## Exact search on QI

def read_table(f = $stdin)
  n = f.gets.chomp.to_i
  (0...n).map{f.gets.chomp}
end

def write_table(t, f = $stdout, no_line_num = false)
  f.puts t.size unless no_line_num
  f.puts t
end

def apply(a, p)
  [p, a].transpose.sort.map{|x| x[1]}
end

def inv(p)
  n = p.size
  apply((0...n).to_a, p)
end

def unapply(a, p)
  apply(a, inv(p))
end

def shuffle(a)
  a.map{|x| [rand, x]}.sort.map{|x| x[1]}
end

def rand_perm0(n)
  (0...n).map{|i|[rand,i]}.sort.map{|x|x[1]}
end

def rand_perm(n)
  shuffle((0...n).to_a)
end

def index_ge(a, k, cmp = 0)
  n = a.size
  b, e = [0, n]
  while b < e
    m = (b + e) / 2
    if (k <=> a[m]) <= cmp
      e = m
    else
      b = m + 1
    end
  end
  return b
end

def index_gt(a, k)
  index_ge(a, k, -1)
end

def num_transactions(m, t)
  n = m.size
  mkeys = m.map{|x|x.split(/,/)[0]}
  k2i = Hash.new
  mkeys.each do |k|
    k2i[k] = k2i.size unless k2i[k]
  end
  tkeys = t.map{|x|x.split(/,/)[0]}
  ct = Array.new(n){0}
  tkeys.each do |k|
    ct[k2i[k]] += 1
  end
  return ct
end

def transactions(m, t)
  n = m.size
  mkeys = m.map{|x|x.split(/,/)[0]}
  k2i = Hash.new
  mkeys.each do |k|
    k2i[k] = k2i.size unless k2i[k]
  end
  ts = Array.new(n){[]}
  t.each do |x|
    xx = x.split(/,/)
    k = xx[0]
    ts[k2i[k]] << xx[1..-1]
  end
  return ts
end

def concat(a, b)
  n = a.size
  (0...n).map{|i| [a[i], b[i]]}
end

def exact_match(a, ks)
  n = a.size
  s, p = [a, (0...n).to_a].transpose.sort.transpose
  ks.map do |k|
    # $stderr.puts k.inspect
    b = index_ge(s, k)
    e = index_gt(s, k)
    w = e - b
    w <= 0 ? rand(n) : p[b + rand(w)]
  end
end

m = read_table()
t = read_table()
m2 = read_table()
t2 = read_table()

n = m2.size
#c = num_transactions(m, t)
#c2 = num_transactions(m2, t2)
a = m.map{|x| x.split(/,/)[1,3]}
a2 = m2.map{|x| x.split(/,/)[1,3]}
r = transactions(m, t).map{|x| x.sort}
r2 = transactions(m2, t2).map{|x| x.sort}

x = (0...n).map{|i| [r[i], a[i]]}
x2 = (0...n).map{|i| [r2[i], a2[i]]}
q = exact_match(x, x2)

write_table(q)
