#!/usr/bin/env ruby

def read_table(f = $stdin)
  n = f.gets.chomp.to_i
  (0...n).map{f.gets.chomp}
end

def write_table(t, f = $stdout, no_line_num = false)
  f.puts t.size unless no_line_num
  f.puts t
end

def apply(a, p)
  [p, a].transpose.sort.map{|x| x[1]}
end

def inv(p)
  n = p.size
  apply((0...n).to_a, p)
end

def unapply(a, p)
  apply(a, inv(p))
end

def shuffle(a)
  a.map{|x| [rand, x]}.sort.map{|x| x[1]}
end

def rand_perm0(n)
  (0...n).map{|i|[rand,i]}.sort.map{|x|x[1]}
end

def rand_perm(n)
  shuffle((0...n).to_a)
end

def sum(a)
  a.inject(0){|x, y| x + y}
end

def dist(a, b)
  a == b ? 0 : 1
end

def hamming_dist(a, b)
  n = a.size
  sum((0...n).map{|i| dist(a[i], b[i])})
end

def hamming_dist2(a, b)
  n = a.size
  sum((0...n).map{|i| hamming_dist(a[i], b[i])})
end

m = read_table().map{|x| x.split(/,/)[1,3]}
t = read_table()
m2 = read_table().map{|x| x.split(/,/)[1,3]}
t2 = read_table()
p = read_table().map{|x|x.to_i}

n = m.size
m2 = apply(m2, p)
d = hamming_dist2(m, m2)

write_table([1.0 - d.to_f / (n * m[0].size)])
