#!/usr/bin/env python3
#
# sec-aprf.py

from common import *

def get_fn(s_p, s_q): return s_p.difference(s_q)
def get_tp(s_p, s_q): return s_p.intersection(s_q)
def get_fp(s_p, s_q): return s_q.difference(s_p)

def print_P_Q(l_s_p, l_s_q, debug = False):
    if not debug: return
    print('P:', l_s_p)
    print('Q:', l_s_q)

def print_fn_tp_fp(s_p, s_q, debug = False):
    if not debug: return
    print(', '.join(['FN:' + str(get_fn(s_p, s_q)),
                     'TP:' + str(get_tp(s_p, s_q)),
                     'FP:' + str(get_fp(s_p, s_q)),
    ]))
    
def print_count_fn_tp_fp(n_fn, n_tp, n_fp, debug = False):
    if not debug: return
    print(', '.join([
        'count(FN):' + str(n_fn),
        'count(TP):' + str(n_tp),
        'count(FP):' + str(n_fp),
    ]))

def get_prf(l_s_p, l_s_q, debug = False):
    l_t_s_p_s_q = list(zip(l_s_p, l_s_q))
    del(l_s_p, l_s_q)
    n_fn = 0; n_tp = 0; n_fp = 0; n_tn = 0
    for s_p, s_q in list(l_t_s_p_s_q):
        n_fn += len(get_fn(s_p, s_q))
        n_tp += len(get_tp(s_p, s_q))
        n_fp += len(get_fp(s_p, s_q))
        if debug: print_fn_tp_fp(s_p, s_q, debug)
    if debug: print_count_fn_tp_fp(n_fn, n_tp, n_fp, debug)
    Precision = n_tp / (n_tp + n_fp)
    Recall = n_tp / (n_tp + n_fn)
    F_value = 2 * Precision * Recall / (Precision + Recall)
    return Precision, Recall, F_value

def print_prf(Precision, Recall, F_value):
    print(', '.join([
        'Precision:' + str(round(Precision, 2)),
        'Recall:' + str(round(Recall, 2)),
        'F_value:' + str(round(F_value, 2))]))

debug = True
l_a = read_ncat()
l_s_p = [set(a.split(',')) for a in l_a[0]]
l_s_q = [set(a.split(',')) for a in l_a[1]]
print_P_Q(l_s_p, l_s_q, debug)
Precision, Recall, F_value = get_prf(l_s_p, l_s_q, debug)
print_prf(Precision, Recall, F_value)
